DROP TABLE ods_renli_contract_terminate;
CREATE TABLE ods_renli_contract_terminate (
contract_code           varchar(50)     COMMENT '合同编号'
,organ_code             varchar(50)     COMMENT 'erp片区code'
,organ_name             varchar(100)    COMMENT 'erp片区名称'
,comm_id                varchar(50)     COMMENT '项目id'
,comm_name              varchar(100)    COMMENT '项目名称'
,contract_type          varchar(100)    COMMENT '合同类型'
,contract_name          varchar(100)    COMMENT '合同名称'
,contract_amount        decimal(16,8)   COMMENT '合同金额'
,party_a                varchar(50)     COMMENT '合作甲方'
,party_b                varchar(50)     COMMENT '合作乙方'
,start_date             varchar(50)     COMMENT '生效日期'
,end_date               varchar(50)     COMMENT '结束日期'
,update_by              varchar(50)     COMMENT '数据更新人'
,update_time            datetime        COMMENT '数据更新时间'
-- ,PRIMARY KEY (contract_code)
) COMMENT='月度合同到到期提醒填报';


SELECT * FROM ods_renli_contract_terminate
SELECT
contract_code           -- 合同编号
,organ_code             -- erp片区code
,organ_name             -- erp片区名称
,comm_id                -- 项目id
,comm_name              -- 项目名称
,contract_type          -- 合同类型
,contract_name          -- 合同名称
,contract_amount        -- 合同金额
,party_a                -- 合作甲方
,party_b                -- 合作乙方
,start_date             -- 生效日期
,end_date               -- 结束日期
,datediff(end_date,current_date) AS expire_day                    -- 距离到期天数
FROM ods_renli_contract_terminate
WHERE 1 = 1
${IF(LEN(p_area)>0," AND organ_code IN ('"+JOINARRAY(p_area,"','")+"')", "")}
${IF(LEN(p_c_type)>0," AND contract_type IN ('"+JOINARRAY(p_c_type,"','")+"')", "")}
${IF(LEN(p_dt_type)>0,
switch(p_dt_type
,'7天提醒',"AND  datediff(end_date,current_date) > 0 AND datediff(end_date,current_date) <= 7"
,'15天提醒',"AND datediff(end_date,current_date) > 0 AND datediff(end_date,current_date) <= 15"
,'30天提醒',"AND datediff(end_date,current_date) > 0 AND datediff(end_date,current_date) <= 30"
,'60天提醒',"AND datediff(end_date,current_date) > 0 AND datediff(end_date,current_date) <= 60"
,'90天提醒',"AND datediff(end_date,current_date) > 0 AND datediff(end_date,current_date) <= 90"
), "")}


;


-- 1、合同到期日-当期日期=90天提醒。显示到期合同总数量，并可下钻明细。
-- 2、合同到期日-当期日期=60天提醒，显示到期合同总数量，并可下钻明细。
-- 3、合同到期日-当期日期=30天提醒，显示到期合同总数量，并可下钻明细。
-- 4、合同到期日-当期日期=15天提醒，显示到期合同总数量，并可下钻明细。
-- 5、合同到期日-当期日期=7天提醒，显示到期合同总数量，并可下钻明细。"
-- VALUE("dict_片区_项目",3,4,D4)

-- VALUE("dict_片区",1,2,B2)
-- VALUE("dict_片区_项目",3,4,C2)