DROP TABLE ods_cost_collection_target;

CREATE TABLE ods_cost_collection_target (
 id int NOT NULL AUTO_INCREMENT     COMMENT '主键(自增)'
,organ_code             varchar(50)     COMMENT 'erp片区code'
,organ_name             varchar(100)    COMMENT 'erp片区名称'
,comm_id                varchar(50)     COMMENT '项目id'
,comm_name              varchar(100)    COMMENT '项目名称'
,ym                     varchar(50)     COMMENT '日期(yyyy-MM格式)'
,lc_fee_rate_target     decimal(28,10)  COMMENT '人力成本费率目标'
,ac_fee_rate_target     decimal(28,10)  COMMENT '行政成本费率目标'
,update_by              varchar(50)     COMMENT '数据更新人'
,update_time            datetime        COMMENT '数据更新时间'
,PRIMARY KEY (id)
) COMMENT='费控目标值填报';

${IF(pIsyear='月度',"", "/*")}
SELECT
 organ_code            -- erp片区code
,organ_name            -- erp片区名称
,comm_id               -- 项目id
,comm_name             -- 项目名称
,ym                    -- 日期(yyyy-MM格式)
,lc_fee_rate_target    -- 人力成本费率目标
,ac_fee_rate_target    -- 行政成本费率目标
FROM ods_cost_collection_target
WHERE ym = '${p_ym}'
 ${IF(pIsyear='月度',"", "*/")}

 ${IF(pIsyear='年度',"", "/*")}
SELECT
    organ_code            -- erp片区code
     ,organ_name            -- erp片区名称
     ,comm_id               -- 项目id
     ,comm_name             -- 项目名称
     ,ym                    -- 日期(yyyy-MM格式)
     ,lc_fee_rate_target    -- 人力成本费率目标
     ,ac_fee_rate_target    -- 行政成本费率目标
FROM ods_cost_collection_target
WHERE length(ym) = 4
AND left(ym,4) = left('${p_ym}',4)
${IF(pIsyear='年度',"", "*/")}
;

SELECT * FROM ods_cost_collection_target;
TRUNCATE TABLE ods_cost_collection_target;


-- VALUE("dict_片区",1,2,B2)
-- VALUE("dict_片区_项目",3,4,C2)